git-sh-setup.shon commit pager test: make fake pager consume all its input (52c02f6)
   1#!/bin/sh
   2#
   3# This is included in commands that either have to be run from the toplevel
   4# of the repository, or with GIT_DIR environment variable properly.
   5# If the GIT_DIR does not look like the right correct git-repository,
   6# it dies.
   7
   8# Having this variable in your environment would break scripts because
   9# you would cause "cd" to be taken to unexpected places.  If you
  10# like CDPATH, define it for your interactive shell sessions without
  11# exporting it.
  12# But we protect ourselves from such a user mistake nevertheless.
  13unset CDPATH
  14
  15# Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and
  16# do not equate an unset IFS with IFS with the default, so here is
  17# an explicit SP HT LF.
  18IFS='   
  19'
  20
  21git_broken_path_fix () {
  22        case ":$PATH:" in
  23        *:$1:*) : ok ;;
  24        *)
  25                PATH=$(
  26                        SANE_TOOL_PATH="$1"
  27                        IFS=: path= sep=
  28                        set x $PATH
  29                        shift
  30                        for elem
  31                        do
  32                                case "$SANE_TOOL_PATH:$elem" in
  33                                (?*:/bin | ?*:/usr/bin)
  34                                        path="$path$sep$SANE_TOOL_PATH"
  35                                        sep=:
  36                                        SANE_TOOL_PATH=
  37                                esac
  38                                path="$path$sep$elem"
  39                                sep=:
  40                        done
  41                        echo "$path"
  42                )
  43                ;;
  44        esac
  45}
  46
  47# @@BROKEN_PATH_FIX@@
  48
  49die () {
  50        die_with_status 1 "$@"
  51}
  52
  53die_with_status () {
  54        status=$1
  55        shift
  56        printf >&2 '%s\n' "$*"
  57        exit "$status"
  58}
  59
  60GIT_QUIET=
  61
  62say () {
  63        if test -z "$GIT_QUIET"
  64        then
  65                printf '%s\n' "$*"
  66        fi
  67}
  68
  69if test -n "$OPTIONS_SPEC"; then
  70        usage() {
  71                "$0" -h
  72                exit 1
  73        }
  74
  75        parseopt_extra=
  76        [ -n "$OPTIONS_KEEPDASHDASH" ] &&
  77                parseopt_extra="--keep-dashdash"
  78
  79        eval "$(
  80                echo "$OPTIONS_SPEC" |
  81                        git rev-parse --parseopt $parseopt_extra -- "$@" ||
  82                echo exit $?
  83        )"
  84else
  85        dashless=$(basename "$0" | sed -e 's/-/ /')
  86        usage() {
  87                die "usage: $dashless $USAGE"
  88        }
  89
  90        if [ -z "$LONG_USAGE" ]
  91        then
  92                LONG_USAGE="usage: $dashless $USAGE"
  93        else
  94                LONG_USAGE="usage: $dashless $USAGE
  95
  96$LONG_USAGE"
  97        fi
  98
  99        case "$1" in
 100                -h)
 101                echo "$LONG_USAGE"
 102                exit
 103        esac
 104fi
 105
 106# Set the name of the end-user facing command in the reflog when the
 107# script may update refs.  When GIT_REFLOG_ACTION is already set, this
 108# will not overwrite it, so that a scripted Porcelain (e.g. "git
 109# rebase") can set it to its own name (e.g. "rebase") and then call
 110# another scripted Porcelain (e.g. "git am") and a call to this
 111# function in the latter will keep the name of the end-user facing
 112# program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it
 113# does will be record as actions done as part of the end-user facing
 114# operation (e.g. "rebase").
 115#
 116# NOTE NOTE NOTE: consequently, after assigning a specific message to
 117# GIT_REFLOG_ACTION when calling a "git" command to record a custom
 118# reflog message, do not leave that custom value in GIT_REFLOG_ACTION,
 119# after you are done.  Other callers of "git" commands that rely on
 120# writing the default "program name" in reflog expect the variable to
 121# contain the value set by this function.
 122#
 123# To use a custom reflog message, do either one of these three:
 124#
 125# (a) use a single-shot export form:
 126#     GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \
 127#         git command-that-updates-a-ref
 128#
 129# (b) save the original away and restore:
 130#     SAVED_ACTION=$GIT_REFLOG_ACTION
 131#     GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
 132#     git command-that-updates-a-ref
 133#     GIT_REFLOG_ACITON=$SAVED_ACTION
 134#
 135# (c) assign the variable in a subshell:
 136#     (
 137#         GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz"
 138#         git command-that-updates-a-ref
 139#     )
 140set_reflog_action() {
 141        if [ -z "${GIT_REFLOG_ACTION:+set}" ]
 142        then
 143                GIT_REFLOG_ACTION="$*"
 144                export GIT_REFLOG_ACTION
 145        fi
 146}
 147
 148git_editor() {
 149        if test -z "${GIT_EDITOR:+set}"
 150        then
 151                GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
 152        fi
 153
 154        eval "$GIT_EDITOR" '"$@"'
 155}
 156
 157git_pager() {
 158        if test -t 1
 159        then
 160                GIT_PAGER=$(git var GIT_PAGER)
 161        else
 162                GIT_PAGER=cat
 163        fi
 164        : ${LESS=-FRSX}
 165        : ${LV=-c}
 166        export LESS LV
 167
 168        eval "$GIT_PAGER" '"$@"'
 169}
 170
 171sane_grep () {
 172        GREP_OPTIONS= LC_ALL=C grep "$@"
 173}
 174
 175sane_egrep () {
 176        GREP_OPTIONS= LC_ALL=C egrep "$@"
 177}
 178
 179is_bare_repository () {
 180        git rev-parse --is-bare-repository
 181}
 182
 183cd_to_toplevel () {
 184        cdup=$(git rev-parse --show-toplevel) &&
 185        cd "$cdup" || {
 186                echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
 187                exit 1
 188        }
 189}
 190
 191require_work_tree_exists () {
 192        if test "z$(git rev-parse --is-bare-repository)" != zfalse
 193        then
 194                die "fatal: $0 cannot be used without a working tree."
 195        fi
 196}
 197
 198require_work_tree () {
 199        test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
 200        die "fatal: $0 cannot be used without a working tree."
 201}
 202
 203require_clean_work_tree () {
 204        git rev-parse --verify HEAD >/dev/null || exit 1
 205        git update-index -q --ignore-submodules --refresh
 206        err=0
 207
 208        if ! git diff-files --quiet --ignore-submodules
 209        then
 210                echo >&2 "Cannot $1: You have unstaged changes."
 211                err=1
 212        fi
 213
 214        if ! git diff-index --cached --quiet --ignore-submodules HEAD --
 215        then
 216                if [ $err = 0 ]
 217                then
 218                    echo >&2 "Cannot $1: Your index contains uncommitted changes."
 219                else
 220                    echo >&2 "Additionally, your index contains uncommitted changes."
 221                fi
 222                err=1
 223        fi
 224
 225        if [ $err = 1 ]
 226        then
 227                test -n "$2" && echo >&2 "$2"
 228                exit 1
 229        fi
 230}
 231
 232# Generate a sed script to parse identities from a commit.
 233#
 234# Reads the commit from stdin, which should be in raw format (e.g., from
 235# cat-file or "--pretty=raw").
 236#
 237# The first argument specifies the ident line to parse (e.g., "author"), and
 238# the second specifies the environment variable to put it in (e.g., "AUTHOR"
 239# for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
 240# committer.
 241pick_ident_script () {
 242        while test $# -gt 0
 243        do
 244                lid=$1; shift
 245                uid=$1; shift
 246                printf '%s' "
 247                /^$lid /{
 248                        s/'/'\\\\''/g
 249                        h
 250                        s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
 251                        s/.*/GIT_${uid}_NAME='&'/p
 252
 253                        g
 254                        s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
 255                        s/.*/GIT_${uid}_EMAIL='&'/p
 256
 257                        g
 258                        s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
 259                        s/.*/GIT_${uid}_DATE='&'/p
 260                }
 261                "
 262        done
 263        echo '/^$/q'
 264}
 265
 266# Create a pick-script as above and feed it to sed. Stdout is suitable for
 267# feeding to eval.
 268parse_ident_from_commit () {
 269        LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
 270}
 271
 272# Parse the author from a commit given as an argument. Stdout is suitable for
 273# feeding to eval to set the usual GIT_* ident variables.
 274get_author_ident_from_commit () {
 275        encoding=$(git config i18n.commitencoding || echo UTF-8)
 276        git show -s --pretty=raw --encoding="$encoding" "$1" -- |
 277        parse_ident_from_commit author AUTHOR
 278}
 279
 280# Clear repo-local GIT_* environment variables. Useful when switching to
 281# another repository (e.g. when entering a submodule). See also the env
 282# list in git_connect()
 283clear_local_git_env() {
 284        unset $(git rev-parse --local-env-vars)
 285}
 286
 287# Generate a virtual base file for a two-file merge. Uses git apply to
 288# remove lines from $1 that are not in $2, leaving only common lines.
 289create_virtual_base() {
 290        sz0=$(wc -c <"$1")
 291        @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add
 292        sz1=$(wc -c <"$1")
 293
 294        # If we do not have enough common material, it is not
 295        # worth trying two-file merge using common subsections.
 296        expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1"
 297}
 298
 299
 300# Platform specific tweaks to work around some commands
 301case $(uname -s) in
 302*MINGW*)
 303        # Windows has its own (incompatible) sort and find
 304        sort () {
 305                /usr/bin/sort "$@"
 306        }
 307        find () {
 308                /usr/bin/find "$@"
 309        }
 310        # git sees Windows-style pwd
 311        pwd () {
 312                builtin pwd -W
 313        }
 314        is_absolute_path () {
 315                case "$1" in
 316                [/\\]* | [A-Za-z]:*)
 317                        return 0 ;;
 318                esac
 319                return 1
 320        }
 321        ;;
 322*)
 323        is_absolute_path () {
 324                case "$1" in
 325                /*)
 326                        return 0 ;;
 327                esac
 328                return 1
 329        }
 330esac
 331
 332# Make sure we are in a valid repository of a vintage we understand,
 333# if we require to be in a git repository.
 334if test -z "$NONGIT_OK"
 335then
 336        GIT_DIR=$(git rev-parse --git-dir) || exit
 337        if [ -z "$SUBDIRECTORY_OK" ]
 338        then
 339                test -z "$(git rev-parse --show-cdup)" || {
 340                        exit=$?
 341                        echo >&2 "You need to run this command from the toplevel of the working tree."
 342                        exit $exit
 343                }
 344        fi
 345        test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
 346                echo >&2 "Unable to determine absolute path of git directory"
 347                exit 1
 348        }
 349        : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
 350fi
 351
 352peel_committish () {
 353        case "$1" in
 354        :/*)
 355                peeltmp=$(git rev-parse --verify "$1") &&
 356                git rev-parse --verify "${peeltmp}^0"
 357                ;;
 358        *)
 359                git rev-parse --verify "${1}^0"
 360                ;;
 361        esac
 362}